Index: src/Patterns/Observer.cpp
===================================================================
--- src/Patterns/Observer.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Patterns/Observer.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -10,5 +10,6 @@
 
 #include <iostream>
-#include <cassert>
+
+#include "Helpers/Assert.hpp"
 
 using namespace std;
@@ -24,13 +25,18 @@
 // See [Gamma et al, 1995] p. 297
 
-map<Observable*, int> Observable::depth;
-map<Observable*,multimap<int,Observer*>*> Observable::callTable;
-set<Observable*> Observable::busyObservables;
-
-// The two functions start_observer_internal and finish_observer_internal
-// have to be used together at all time. Never use these functions directly
-// START_OBSERVER and FINISH_OBSERVER also construct a bogus while(0) loop
-// thus producing compiler-errors whenever only one is used
-
+map<Observable*, int> Observable::depth;  //!< Map of Observables to the depth of the DAG of Observers
+map<Observable*,multimap<int,Observer*> > Observable::callTable; //!< Table for each Observable of all its Observers
+std::map<Observable*,std::set<Notification*> > Observable::notifications;
+set<Observable*> Observable::busyObservables; //!< Set of Observables that are currently busy notifying their sign-on'ed Observers
+
+/** Attaching Sub-observables to Observables.
+ * Increases entry in Observable::depth for this \a *publisher by one.
+ *
+ * The two functions \sa start_observer_internal() and \sa finish_observer_internal()
+ * have to be used together at all time. Never use these functions directly
+ * START_OBSERVER and FINISH_OBSERVER also construct a bogus while(0) loop
+ * thus producing compiler-errors whenever only one is used.
+ * \param *publisher reference of sub-observable
+ */
 void Observable::start_observer_internal(Observable *publisher){
   // increase the count for this observable by one
@@ -40,4 +46,14 @@
 }
 
+/** Detaching Sub-observables from Observables.
+ * Decreases entry in Observable::depth for this \a *publisher by one. If zero, we
+ * start notifying all our Observers.
+ *
+ * The two functions start_observer_internal() and finish_observer_internal()
+ * have to be used together at all time. Never use these functions directly
+ * START_OBSERVER and FINISH_OBSERVER also construct a bogus while(0) loop
+ * thus producing compiler-errors whenever only one is used.
+ * \param *publisher reference of sub-observable
+ */
 void Observable::finish_observer_internal(Observable *publisher){
   // decrease the count for this observable
@@ -53,4 +69,15 @@
 }
 
+void Observable::enque_notification_internal(Observable *publisher, Notification_ptr notification){
+  ASSERT(notification->owner==publisher,"Some object tried to send a notification it does not own");
+  notifications[publisher].insert(notification);
+}
+
+/** Constructor for Observable Protector.
+ * Basically, calls start_observer_internal(). Hence use this class instead of
+ * calling the function directly.
+ *
+ * \param *protege Observable to be protected.
+ */
 Observable::_Observable_protector::_Observable_protector(Observable *_protege) :
   protege(_protege)
@@ -59,4 +86,10 @@
 }
 
+/** Destructor for Observable Protector.
+ * Basically, calls finish_observer_internal(). Hence use this class instead of
+ * calling the function directly.
+ *
+ * \param *protege Observable to be protected.
+ */
 Observable::_Observable_protector::~_Observable_protector()
 {
@@ -66,5 +99,8 @@
 /************* Notification mechanism for observables **************/
 
-
+/** Notify all Observers of changes.
+ * Puts \a *this into Observable::busyObservables, calls Observer::update() for all in callee_t
+ * and removes from busy list.
+ */
 void Observable::notifyAll() {
   // we are busy notifying others right now
@@ -73,19 +109,38 @@
   // see if anyone has signed up for observation
   // and call all observers
-  if(callTable.count(this)) {
-    // elements are stored sorted by keys in the multimap
-    // so iterating over it gives us a the callees sorted by
-    // the priorities
-    callees_t *callees = callTable[this];
-    callees_t::iterator iter;
-    for(iter=callees->begin();iter!=callees->end();iter++){
-      (*iter).second->update(this);
-    }
-  }
-  // done with notification, we can leave the set of busy subjects
+  try {
+    if(callTable.count(this)) {
+      // elements are stored sorted by keys in the multimap
+      // so iterating over it gives us a the callees sorted by
+      // the priorities
+      callees_t callees = callTable[this];
+      callees_t::iterator iter;
+      for(iter=callees.begin();iter!=callees.end();++iter){
+        (*iter).second->update(this);
+      }
+    }
+  }
+  ASSERT_NOCATCH("Exception thrown from Observer Update");
+
+  // send out all notifications that need to be done
+
+  notificationSet currentNotifications = notifications[this];
+  for(notificationSet::iterator it = currentNotifications.begin();
+      it != currentNotifications.end();++it){
+    (*it)->notifyAll();
+  }
+
+  notifications.erase(this);
+
+   // done with notification, we can leave the set of busy subjects
   busyObservables.erase(this);
 }
 
-// this handles passing on updates from sub-Observables
+
+/** Handles passing on updates from sub-Observables.
+ * Mimicks basically the Observer::update() function.
+ *
+ * \param *publisher The \a *this we observe.
+ */
 void Observable::update(Observable *publisher) {
   // circle detection
@@ -94,7 +149,7 @@
     // observers, but still we are called by one of our sub-Observables
     // we cannot be sure observation will still work at this point
-    cerr << "Circle detected in observation-graph." << endl;
-    cerr << "Observation-graph always needs to be a DAG to work correctly!" << endl;
-    cerr << "Please check your observation code and fix this!" << endl;
+    ASSERT(0,"Circle detected in observation-graph.\n"
+             "Observation-graph always needs to be a DAG to work correctly!\n"
+             "Please check your observation code and fix this!\n");
     return;
   }
@@ -109,64 +164,127 @@
 }
 
-// methods to sign-on and off
+/** Sign on an Observer to this Observable.
+ * Puts \a *target into Observable::callTable list.
+ * \param *target Observer
+ * \param priority number in [-20,20]
+ */
 void Observable::signOn(Observer *target,int priority) {
-  assert(priority>=-20 && priority<=+20 && "Priority out of range [-20:+20]");
+  ASSERT(priority>=-20 && priority<=+20, "Priority out of range [-20:+20] when signing on Observer");
   bool res = false;
-  callees_t *callees = 0;
-  if(callTable.count(this)){
-    callees = callTable[this];
-  }
-  else {
-    callees = new multimap<int,Observer*>;
-    callTable.insert(pair<Observable*,callees_t*>(this,callees));
-  }
+  callees_t &callees = callTable[this];
 
   callees_t::iterator iter;
-  for(iter=callees->begin();iter!=callees->end();iter++){
+  for(iter=callees.begin();iter!=callees.end();++iter){
     res |= ((*iter).second == target);
   }
   if(!res)
-    callees->insert(pair<int,Observer*>(priority,target));
-}
-
+    callees.insert(pair<int,Observer*>(priority,target));
+}
+
+/** Sign off an Observer from this Observable.
+ * Removes \a *target from Observable::callTable list.
+ * \param *target Observer
+ */
 void Observable::signOff(Observer *target) {
-  assert(callTable.count(this) && "SignOff called for an Observable without Observers.");
-  callees_t *callees = callTable[this];
+  ASSERT(callTable.count(this),"SignOff called for an Observable without Observers.");
+  callees_t &callees = callTable[this];
   callees_t::iterator iter;
-  for(iter=callees->begin();iter!=callees->end();iter++) {
-    if((*iter).second == target)
-      callees->erase(iter);
-  }
-  if(callees->empty()){
+  callees_t::iterator deliter;
+  for(iter=callees.begin();iter!=callees.end();) {
+    if((*iter).second == target) {
+      callees.erase(iter++);
+    }
+    else {
+      ++iter;
+    }
+  }
+  if(callees.empty()){
     callTable.erase(this);
-    delete callees;
-  }
-}
-
-// when an sub-observerable dies we usually don't need to do anything
+  }
+}
+
+void Observable::signOn(Observer *target, Notification_ptr notification){
+  ASSERT(notification->owner==this,
+         "Trying to sign on for a notification that is not provided by this object");
+
+  notification->addObserver(target);
+}
+
+void Observable::signOff(Observer *target, Notification_ptr notification){
+  ASSERT(notification->owner==this,
+         "Trying to sign off from a notification that is not provided by this object");
+
+  notification->removeObserver(target);
+}
+
+bool Observable::isBlocked(){
+  return depth.count(this) > 0;
+}
+
+/** Handles sub-observables that just got killed
+ *  when an sub-observerable dies we usually don't need to do anything
+ *  \param *publisher Sub-Observable.
+ */
 void Observable::subjectKilled(Observable *publisher){
 }
 
+/** Constructor for class Observable.
+ */
 Observable::Observable()
 {}
 
-// when an observable is deleted, we let all our observers know
+/** Destructor for class Observable.
+ * When an observable is deleted, we let all our observers know. \sa Observable::subjectKilled().
+ */
 Observable::~Observable()
 {
   if(callTable.count(this)) {
     // delete all entries for this observable
-    callees_t *callees = callTable[this];
+    callees_t callees = callTable[this];
     callees_t::iterator iter;
-    for(iter=callees->begin();iter!=callees->end();iter++){
+    for(iter=callees.begin();iter!=callees.end();++iter){
       (*iter).second->subjectKilled(this);
     }
     callTable.erase(this);
-    delete callees;
-  }
-}
-
+  }
+}
+
+/** Constructor for class Observer.
+ */
 Observer::Observer()
 {}
 
+/** Destructor for class Observer.
+ */
 Observer::~Observer()
 {}
+
+/**
+ * Method for specialized notifications.
+ * Most Observers wont need or use this, so it is implemented
+ * empty in the base case;
+ */
+void Observer::recieveNotification(Observable *publisher, Notification_ptr notification){
+  ASSERT(0,"Notification received by object that did not sign on for it.");
+}
+
+Notification::Notification(Observable *_owner) :
+    owner(_owner)
+{}
+
+Notification::~Notification(){}
+
+void Notification::addObserver(Observer *target){
+  targets.insert(target);
+}
+
+void Notification::removeObserver(Observer *target){
+  targets.erase(target);
+}
+
+void Notification::notifyAll(){
+  for(std::set<Observer*>::iterator it=targets.begin();
+      it!=targets.end();++it){
+    (*it)->recieveNotification(owner,this);
+  }
+}
Index: src/Patterns/Observer.hpp
===================================================================
--- src/Patterns/Observer.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Patterns/Observer.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -16,5 +16,5 @@
  *
  * Observers register themselves with the observables to be notified when something changes.
- * In the Observable code that changes attributes should be started with OBSERVE;. This macro
+ * In the Observable code that changes, attributes should be started with OBSERVE;. This macro
  * locks the observer mechanism while changes are done. At the end of the scope in which the
  * macro was placed the lock is released. When the last lock is released all changes are
@@ -29,8 +29,28 @@
 
 class Observable;
+class Notification;
 
+// Pointers to notifications are used for unique identification
+// using this typedef makes it hard for others to mess up this
+// identification process
+typedef Notification *const Notification_ptr;
+
+/**
+ * An Observer is notified by all Observed objects, when anything changes.
+ *
+ * If a simple change is done to an Object the Obervable will call the update() method
+ * of all signed on observers, passing itself as a parameter for identification. The
+ * Observers should then react to the changes and update themselves accordingly.
+ *
+ * If an observed Object is destroyed it will call the subjectKilled() method
+ * of all signed on Observers, again passing itself as a parameter for identification.
+ * The Observers should handle the destruction of an observed Object gracefully, i.e.
+ * set themselves inactive, display something else, etc. There is no need
+ * to sign of from the dying object, since this will be handled by the Observable destructor.
+ */
 class Observer
 {
   friend class Observable;
+  friend class Notification;
 public:
   Observer();
@@ -38,8 +58,30 @@
 
 protected:
+  /**
+   * This method is called upon changes of the Observable
+   */
   virtual void update(Observable *publisher)=0;
+
+  /**
+   * This method is called when a special named change
+   * of the Observable occured
+   */
+  virtual void recieveNotification(Observable *publisher, Notification_ptr notification);
+
+  /**
+   * This method is called when the observed object is destroyed.
+   */
   virtual void subjectKilled(Observable *publisher)=0;
 };
 
+/**
+ * An Observable implements all neccessary method for being observed.
+ *
+ * That is, it provides methods for signing on and of from an
+ * Observable that can be used by any observer. The actual
+ * observer-mechanism is handled at a central static place
+ * to avoid memory issues when many observable are around but only few
+ * are actually observed.
+ */
 class Observable : public Observer {
 public:
@@ -47,6 +89,38 @@
   virtual ~Observable();
 
+  /**
+   * Sign an Observer on to this Observable. The Observer will be notified
+   * whenever something inside the Observable changes. The Observer can
+   * assign itself a priority for the changes in the range of -20:+20.
+   * The Observer with lower priority will be called before the others,
+   * same as with Unix nice-levels. This can be used when an Object
+   * contains other objects that observe it (derived values), and these objects have
+   * to recalculate their states before the changes should be propageted to the
+   * UI. A default priority of 0 should be fine in most cases, since there is
+   * ussually no need to order the update sequence.
+   */
   virtual void signOn(Observer *target, int priority=0);
+
+  /**
+   * Sign of a previously signed on Observer. After this no more
+   * updates will be recieved from that observer.
+   */
   virtual void signOff(Observer *target);
+
+  /**
+   * Sign on for specialized notifications
+   */
+  virtual void signOn(Observer *target, Notification_ptr notification);
+
+  /**
+   * Stop receiving a specialized notification
+   */
+  virtual void signOff(Observer *target, Notification_ptr notification);
+
+  /**
+   * Ask an Observer if it is currently in a blocked state, i.e. if
+   * Changes are in Progress, that are not yet published.
+   */
+  virtual bool isBlocked();
 
 protected:
@@ -68,12 +142,23 @@
   static void finish_observer_internal(Observable *publisher);
 
+  static void enque_notification_internal(Observable *publisher, Notification_ptr notification);
+
 private:
   typedef std::multimap<int,Observer*> callees_t;
+  typedef std::set<Notification*> notificationSet;
   static std::map<Observable*, int> depth;
-  static std::map<Observable*,callees_t*> callTable;
+  static std::map<Observable*,callees_t> callTable;
+  static std::map<Observable*,notificationSet> notifications;
   static std::set<Observable*> busyObservables;
 
+
+  //! @cond
   // Structure for RAII-Style notification
 protected:
+  /**
+   * This structure implements the Observer-mechanism RAII-Idiom.
+   * It triggers certain functions on creation and destruction so that
+   * Observer mechanisms can be linked to scope block.
+   */
   class _Observable_protector {
   public:
@@ -83,4 +168,21 @@
     Observable *protege;
   };
+  //! @endcond
+};
+
+class Notification {
+  friend class Observable;
+public:
+  Notification(Observable *_owner);
+  virtual ~Notification();
+protected:
+
+  void addObserver(Observer *target);
+  void removeObserver(Observer *target);
+
+  void notifyAll();
+private:
+  Observable * const owner;
+  std::set<Observer*> targets;
 };
 
@@ -89,7 +191,5 @@
 #define PASTE_HELPER(a,b) a ## b
 #define OBSERVE Observable::_Observable_protector PASTE(_scope_obs_protector_,__LINE__)(this)
-// deprecated macros from before RAII was used
-//#define START_OBSERVER Observable::start_observer_internal(this);do{do{}while(0)
-//#define FINISH_OBSERVER }while(0);Observable::finish_observer_internal(this)
-//#define RETURN_OBSERVER( retval ) do{Observable::finish_observer_internal(this); return (retval);}while(0)
+#define NOTIFY(notification) do{Observable::enque_notification_internal(this,notification);}while(0)
+
 #endif /* OBSERVER_HPP_ */
Index: src/Patterns/Singleton.hpp
===================================================================
--- src/Patterns/Singleton.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Patterns/Singleton.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,278 @@
+/*
+ * Singleton.hpp
+ *
+ *  Created on: Mar 10, 2010
+ *      Author: crueger
+ */
+
+#ifndef SINGLETON_HPP_
+#define SINGLETON_HPP_
+
+#include <cassert>
+#include <boost/thread.hpp>
+
+#include "defs.hpp"
+
+/**
+ * This template produces the generic singleton pattern using the CRTP idiom.
+ *
+ * <h1> Singleton Howto </h1>
+ * <h2> Introduction </h2>
+ *
+ * A Singleton is a class of which there can only be a single Object in the programm. It is
+ * described as an design-pattern in Gof:96 (the famous design-pattern book). In the
+ * molecuilder there are so far several Singletons serving a wide range of purposes:
+ *
+ * - the World, which handles all atoms, molecules and bonds
+ * - the ActionRegistry, which stores all created actions by name for later use
+ * - the UIFactory, which is an AbstractFactory (another design-pattern from Gof:96) and
+ *   handles all creation of gui elements to ensure a single type throughout the programm
+ * - the logger and errorLogger classes, that can be used to output messages on the screen
+ *   depending on certain conditions
+ *
+ * Because those classes can only be instantiated once you cannot simply call <code>new World()</code>
+ * or <code>delete</code> on them. Rather they have to be constructed and accessed using the singleton
+ * mechanism. This mechanism consists of four static functions (and a fifth that is used internally,
+ * but we will get to that later). These functions are:
+ *
+ * - <code>Singleton& Singleton::getInstance()</code> : returns the instance of the singleton as
+ *    a reference
+ * - <code>Singleton* Singleton::getPointer()</code> : returns the instance of the singleton as a
+ *    pointer
+ * - <code>void Singleton::purgeInstance()</code> : destroys the single Instance of the singleton
+ * - <code>Singleton& Singleton::resetInstance()</code> : resets the Singleton, i.e. destroys the
+ *    old instance and creates a new one
+ *
+ * If you need the instance of the singleton it is usually fine just to use one off the accessor
+ * functions (i.e. <code>getInstance()</code> or <code>getPointer()</code>. Any creation of the
+ * Singleton is then handled by these functions, so that the same object will be returned whenever
+ * one of these functions is called. This easy process is true for most singletons you will need
+ * to use. The only special singleton is the UIFactory.
+ *
+ * <h3>Special functions of the UIFactory</h3>
+ *
+ * If you simply call the <code>getInstance()</code> method of the UIFactory class the program
+ * will crash. This happens, because the UIFactory in itself is abstract and needs to know what
+ * kind of user interface it should produce later on. You need to tell the class the type of UI
+ * using the void <code>UIFactory::makeUserInterface(InterfaceTypes type)</code> method. This will
+ * also take care of creating the sole instance, so that the accessor functions will work afterwards.
+ * What this also means is, that you cannot <code>reset()</code> the UIFactory, because at that
+ * point it wont know anymore what to construct. A sequence of <code>UIFactory::purgeInstance()</code>,
+ * <code>UIFactory::makeUserInterface()</code> and <code>UIFactory::getInstance()</code> will work
+ * though.
+ *
+ * In order to make life easier and propagate changes to the singleton mechanism to all those
+ * classes, there is a simple framework class that can be used to make any other class a
+ * singleton through inheritance. This class can be found in the Pattern directory.
+ *
+ * <h2>How to make a class Singleton</h2>
+ *
+ * Most of the time you will only need singletons that don't require additional
+ * information for creation. So I will cover the basic case for constructing singletons
+ * first and then explain what has to be changed to make it accept special parameters.
+ * Singletons are created by inheriting from the <code>Singleton<class T></code> template
+ * using the Curiously recurring template pattern (CRTP). What this means is, that the
+ * class they inherit from carries the inheriting class as a template parameter. For example
+ * <code>class MySingletonExaple : public Singleton<MySingletonExample>{...}</code>. If you
+ * want to know more about this idiom have a look at the
+ * <A HREF="http://en.wikipedia.org/wiki/Curiously_recurring_template_pattern">wikipedia
+ * page for this idiom</A>, but don't worry if you don't quite get how this works for now, for
+ * the use of the singleton framework this is not important.
+ *
+ * If you want to make a class a singleton you can use the following sequence of steps.
+ *
+ * - Inherit from the singleton pattern using the CRTP as above:<br>
+ *   @code
+ *     class MySingletonExaple : public Singleton<MySingletonExample>{ ...}
+ *   @endcode
+ * - Make constructor and destructor private to avoid creation or destruction from
+ *   outside the class:<br>
+ *    @code
+ *      class MySingletonExaple : public Singleton<MySingletonExample>{
+ *        private:
+ *          MySingletonExample();
+ *          ~MySingletonExample();
+ *      ...}
+ *    @endcode
+ * - give the inherited class access to the class internals using a friend declaration:<br>
+ *    @code
+ *       class MySingletonExaple : public Singleton<MySingletonExample>{
+ *         friend class Singleton<MySingletonExample>; // don't forget the template parameters here
+ *         private:
+ *           MySingletonExample();
+ *           ~MySingletonExample();
+ *       ...}
+ *    @endcode
+ *
+ * - include the file "Patterns/Singleton_impl.hpp" that carries the implementation details of
+ *   the singleton functions in your implementation file of the class.
+ * - make the compiler construct the template instantiations. For this you can use the defined
+ *   keyword <code>CONSTRUCT_SINGLETON(name)</code> at any toplevel point in the implementation
+ *   file:<br>
+ *    @code
+ *       void MySingletonExample::foo(){...}
+ *       void MySingletonExample::bar(){...}
+ *       CONSTRUCT_SINGLETON(MySingletonExample) // no ; after this
+ *     @endcode
+ *
+ * <h3>Singleton with initialization parameters</h3>
+ *
+ * Sometimes it is necessary for a singleton to be passed some initilization parameters. For
+ * example the UIFactory mentioned above needs to know what kind of user interface it has to
+ * produce. Making a singleton that takes initialization parameters is only sligtly different
+ * from the steps lined out above. Here are all the differences:
+ *
+ * - pass an extra <code>false</code> to the template to deactivate the standard instantiation
+ *   mechanism
+ * - write a method that handles the special parameters and instantiation. In this method you
+ *   can use the <code>setInstance(T*)</code> method inherited from the singleton pattern to set
+ *   the created instance. The <code>setInstance()</code> method will only work when the
+ *   <code>false<code> template parameter has been set and produce errors otherwise.
+ *
+ */
+template <class T, bool _may_create=true>
+class Singleton
+{
+private:
+  /**
+   * simple auto_ptr that is used by Singleton template
+   *
+   * This ptr_t allows destruction of the object using a private destructor,
+   * when only the Singleton pattern is friend with the class
+   *
+   * All methods have similar sematics to auto_ptr
+   */
+  class ptr_t {
+  public:
+    ptr_t();
+    ptr_t(T* _content);
+    ~ptr_t();
+    T& operator*();
+    T* get();
+    void reset(T* _content);
+    void reset();
+    ptr_t& operator=(const ptr_t& rhs);
+  private:
+    mutable T* content;
+  };
+
+  /**
+   * This object handles the actual creation inside the singleton
+   *
+   * Using template specialization this will allways know what it can
+   * do or cannot do at compile time
+   */
+  template<class creator_T, bool creator_may_create>
+  struct creator_t {
+    inline static creator_T* make();
+    inline static void set(creator_T*&,creator_T*);
+  };
+
+  // specialization to allow fast creations
+
+  /**
+   * Specialized template that allows automatic construction only
+   */
+  template<class creator_T>
+  struct creator_t<creator_T,true>{
+    inline static creator_T* make(){
+      return new creator_T();
+    }
+
+    inline static void set(creator_T*&,creator_T*){
+      assert(0 && "Cannot set the Instance for a singleton of this type");
+    }
+  };
+
+  /**
+   * specialized template that allows setting only
+   */
+  template<class creator_T>
+  struct creator_t<creator_T,false>{
+    inline static creator_T* make(){
+      assert(0 && "Cannot create a singleton of this type directly");
+    }
+    inline static void set(ptr_t& dest,creator_T* src){
+      dest.reset(src);
+    }
+  };
+
+  // this is used for creation
+  typedef creator_t<T,_may_create> creator; //< the creator used
+
+public:
+  // make the state of this singleton accessible
+  static const bool may_create=_may_create; //!< the type of singleton that we have
+
+  /**
+   * returns the instance of this Singleton as a reference
+   *
+   * If no Singleton exists at this point and we are allowed to create one
+   * a new one is created and stored inside the singleton
+   *
+   * If no automatic creation is allowed, make sure to create an instance first
+   * using the appropriate methods of the derived class. Otherwise this method
+   * would fail.
+   */
+  static T& getInstance();
+
+  /**
+   * returns the instance of this singleton as a pointer
+   *
+   * If no Singleton exists at this point and we are allowed to create one
+   * a new one is created and stored inside the singleton.
+   *
+   * If no automatic creation is allowed, make sure to create an instance first
+   * using the appropriate methods of the derived class. Otherwise this method
+   * would fail.
+   */
+  static T* getPointer();
+
+  /**
+   * destroys the current instance of this singleton
+   */
+  static void purgeInstance();
+
+  /**
+   * destroys the current instance of the singleton and immidiately constructs
+   * a new one. Similar to using <code>purgeInstance()</code> and <code>getInstance()</code>
+   * but plays more nicely when observers are present. Especially the new instance is created
+   * before the old one is destroyed so observers can switch their targets, when they are notified
+   * of the destruction.
+   *
+   * If no automatic creation is allowed this method wont work.
+   */
+  static T&   resetInstance();
+
+protected:
+  /**
+   * Method used to set the instance, when no automatic creation is allowed.
+   *
+   * Call this after the instantiation method in the derived class has created
+   * it's instance and want's the singleton mechanism to keep it around for later
+   * use.
+   *
+   * This method will always fail when automatic creation is enabled.
+   */
+  static void setInstance(T*);
+
+
+  /**
+   * empty constructor to allow creation of subclases
+   */
+  Singleton();
+
+private:
+  /**
+   * the copy constructor is private to avoid accidental copying of Singletons, for example
+   * when passing singletons to functions by value instead of by reference. If you
+   * need copying of singletons call the default constructor in the copy constructor
+   * of the derived object. The copyied object wont be known to the singleton mechanism.
+   */
+  Singleton(const Singleton&);
+
+  static boost::recursive_mutex instanceLock; //!< a lock for the pointer of the instance
+  static ptr_t theInstance; //!< the actual instance of the singleton
+};
+
+#endif /* SINGLETON_HPP_ */
